#include <cstdlib>
#include <cstdio>
#include <cassert>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXVAL 1000000000

struct ins {
	enum tp { NUM, POP, INV, DUP, SWP, ADD, SUB, MUL, DIV, MOD };
	tp type;
	int arg;
};

static const char *ins2str(ins::tp type) {
    switch(type) {
        case ins::NUM: return "NUM";
        case ins::POP: return "POP";
        case ins::INV: return "INV";
        case ins::DUP: return "DUP";
        case ins::SWP: return "SWP";
        case ins::ADD: return "ADD";
        case ins::SUB: return "SUB";
        case ins::MUL: return "MUL";
        case ins::DIV: return "DIV";
        case ins::MOD: return "MOD";
        default: return NULL;
    }
}

static ins::tp parse_ins(const char *buf) {
    if(strcmp(buf, "NUM") == 0) return ins::NUM;
    if(strcmp(buf, "POP") == 0) return ins::POP;
    if(strcmp(buf, "INV") == 0) return ins::INV;
    if(strcmp(buf, "DUP") == 0) return ins::DUP;
    if(strcmp(buf, "SWP") == 0) return ins::SWP;
    if(strcmp(buf, "ADD") == 0) return ins::ADD;
    if(strcmp(buf, "SUB") == 0) return ins::SUB;
    if(strcmp(buf, "MUL") == 0) return ins::MUL;
    if(strcmp(buf, "DIV") == 0) return ins::DIV;
    if(strcmp(buf, "MOD") == 0) return ins::MOD;
    assert(false);
}

static void armageddon() {
    printf("ERROR\n");
    exit(1);
}

static void solve()
{
	vector<ins> INS;
    vector<int> stack;

	for(;;) {
		static char buf[8];
		scanf("%s", buf);
		if(strcmp(buf, "QUIT") == 0) exit(0);
		if(strcmp(buf, "END") == 0) break;

		ins ins;
        ins.type = parse_ins(buf);
        if(ins.type == ins::NUM) scanf("%d", &ins.arg);
        INS.push_back(ins);
	}

    int n;
    scanf("%d",&n);
    while(n--)
    {
        int res; long long resres;
        scanf("%d",&res);
        stack.clear();
        stack.push_back(res);

        for(int i=0; i<INS.size(); i++) {
            for(int j=0; j<stack.size(); j++) printf("%d ", stack[j]);
            printf(" | %s\n",ins2str(INS[i].type));
            switch(INS[i].type) {
                case ins::NUM: stack.push_back(INS[i].arg); break;
                case ins::POP: if(!stack.size()) armageddon(); stack.pop_back(); break;
                case ins::INV: if(!stack.size()) armageddon(); stack.back() = -stack.back(); break;
                case ins::DUP: if(!stack.size()) armageddon(); stack.push_back((int)stack.back()); break;
                case ins::SWP: if(stack.size()<2) armageddon(); swap(stack[stack.size()-1], stack[stack.size()-2]); break;
                case ins::ADD: if(stack.size()<2) armageddon();
                    res = stack[stack.size()-2] + stack[stack.size()-1];
                    if(abs(res) > MAXVAL) armageddon();
                    stack.pop_back();
                    stack.back() = res;
                    break;
                case ins::SUB: if(stack.size()<2) armageddon();
                    res = stack[stack.size()-2] - stack[stack.size()-1];
                    if(abs(res) > MAXVAL) armageddon();
                    stack.pop_back();
                    stack.back() = res;
                    break;
                case ins::MUL: if(stack.size()<2) armageddon();
                    resres = 1LL*stack[stack.size()-2] * 1LL*stack[stack.size()-1];
                    if(abs(resres) > MAXVAL) armageddon();
                    stack.pop_back();
                    stack.back() = resres;
                    break;
                case ins::DIV: if(stack.size()<2) armageddon();
                    if(stack.back() == 0) armageddon();
                    res = stack[stack.size()-2] / stack[stack.size()-1];
                    stack.pop_back();
                    stack.back() = res;
                    break;
                case ins::MOD: if(stack.size()<2) armageddon();
                    if(stack.back() == 0) armageddon();
                    res = stack[stack.size()-2] % stack[stack.size()-1];
                    stack.pop_back();
                    stack.back() = res;
                    break;
            }
        }

        if(stack.size() != 1) armageddon();
        printf("%d\n", stack.back());

        continue;
    }

    printf("\n");
}

int main(void) {
	for(;;) solve();
}

